#!/bin/bash

ref_map.pl -T 4 -m 3 \
	-X "cstacks:-n 2" \
	-b 1 -D "SCA with ddRAD only" -S \
	-X "populations:-r 0.5"\
	-X "populations:-a 0.05" -X "populations:--fstats" \
	-X "populations:--vcf" -X "populations:--plink" \
	-X "populations:-p 3" \
	-O ./sca_popmap_ddrad.txt -o ./results/stacks/ \
	-s ./samples/sample_FEM001_align.sam \
	-s ./samples/sample_FEM002_align.sam \
	-s ./samples/sample_FEM004_align.sam \
	-s ./samples/sample_FEM005_align.sam \
	-s ./samples/sample_FEM006_align.sam \
	-s ./samples/sample_FEM008_align.sam \
	-s ./samples/sample_FEM009_align.sam \
	-s ./samples/sample_FEM010_align.sam \
	-s ./samples/sample_FEM011_align.sam \
	-s ./samples/sample_FEM013_align.sam \
	-s ./samples/sample_FEM014_align.sam \
	-s ./samples/sample_FEM015_align.sam \
	-s ./samples/sample_FEM016_align.sam \
	-s ./samples/sample_FEM017_align.sam \
	-s ./samples/sample_FEM018_align.sam \
	-s ./samples/sample_FEM019_align.sam \
	-s ./samples/sample_FEM020_align.sam \
	-s ./samples/sample_FEM021_align.sam \
	-s ./samples/sample_FEM022_align.sam \
	-s ./samples/sample_FEM023_align.sam \
	-s ./samples/sample_FEM024_align.sam \
	-s ./samples/sample_FEM025_align.sam \
	-s ./samples/sample_FEM026_align.sam \
	-s ./samples/sample_FEM027_align.sam \
	-s ./samples/sample_FEM028_align.sam \
	-s ./samples/sample_FEM029_align.sam \
	-s ./samples/sample_FEM030_align.sam \
	-s ./samples/sample_FEM031_align.sam \
	-s ./samples/sample_FEM032_align.sam \
	-s ./samples/sample_FEM033_align.sam \
	-s ./samples/sample_FEM034_align.sam \
	-s ./samples/sample_FEM035_align.sam \
	-s ./samples/sample_FEM036_align.sam \
	-s ./samples/sample_FEM037_align.sam \
	-s ./samples/sample_FEM039_align.sam \
	-s ./samples/sample_FEM041_align.sam \
	-s ./samples/sample_FEM046_align.sam \
	-s ./samples/sample_FEM047_align.sam \
	-s ./samples/sample_FEM051_align.sam \
	-s ./samples/sample_FEM052_align.sam \
	-s ./samples/sample_FEM054-1_align.sam \
	-s ./samples/sample_FEM056_align.sam \
	-s ./samples/sample_FEM058_align.sam \
	-s ./samples/sample_FEM064_align.sam \
	-s ./samples/sample_FEM066_align.sam \
	-s ./samples/sample_FEM067_align.sam \
	-s ./samples/sample_FEM072_align.sam \
	-s ./samples/sample_FEM074_align.sam \
	-s ./samples/sample_FEM076_align.sam \
	-s ./samples/sample_FEM077_align.sam \
	-s ./samples/sample_FEM078_align.sam \
	-s ./samples/sample_FEM080_align.sam \
	-s ./samples/sample_FEM081_align.sam \
	-s ./samples/sample_FEM082_align.sam \
	-s ./samples/sample_FEM083_align.sam \
	-s ./samples/sample_FEM084_align.sam \
	-s ./samples/sample_FEM087_align.sam \
	-s ./samples/sample_NPM005_align.sam \
	-s ./samples/sample_NPM006_align.sam \
	-s ./samples/sample_NPM007_align.sam \
	-s ./samples/sample_NPM008_align.sam \
	-s ./samples/sample_NPM010_align.sam \
	-s ./samples/sample_NPM011_align.sam \
	-s ./samples/sample_NPM012_align.sam \
	-s ./samples/sample_NPM1128_align.sam \
	-s ./samples/sample_OFF001_align.sam \
	-s ./samples/sample_OFF004_align.sam \
	-s ./samples/sample_OFF005_align.sam \
	-s ./samples/sample_OFF006_align.sam \
	-s ./samples/sample_OFF007_align.sam \
	-s ./samples/sample_OFF008_align.sam \
	-s ./samples/sample_OFF009_align.sam \
	-s ./samples/sample_OFF010_align.sam \
	-s ./samples/sample_OFF011_align.sam \
	-s ./samples/sample_OFF012_align.sam \
	-s ./samples/sample_OFF013_align.sam \
	-s ./samples/sample_OFF014_align.sam \
	-s ./samples/sample_OFF015_align.sam \
	-s ./samples/sample_OFF016-1_align.sam \
	-s ./samples/sample_OFF016_align.sam \
	-s ./samples/sample_OFF017_align.sam \
	-s ./samples/sample_OFF018_align.sam \
	-s ./samples/sample_OFF020_align.sam \
	-s ./samples/sample_OFF022_align.sam \
	-s ./samples/sample_OFF024_align.sam \
	-s ./samples/sample_OFF025_align.sam \
	-s ./samples/sample_OFF026_align.sam \
	-s ./samples/sample_OFF027-1_align.sam \
	-s ./samples/sample_OFF027_align.sam \
	-s ./samples/sample_OFF028_align.sam \
	-s ./samples/sample_OFF029_align.sam \
	-s ./samples/sample_OFF030_align.sam \
	-s ./samples/sample_OFF031_align.sam \
	-s ./samples/sample_OFF032-1_align.sam \
	-s ./samples/sample_OFF032_align.sam \
	-s ./samples/sample_OFF033_align.sam \
	-s ./samples/sample_OFF034_align.sam \
	-s ./samples/sample_OFF035_align.sam \
	-s ./samples/sample_OFF036_align.sam \
	-s ./samples/sample_OFF037_align.sam \
	-s ./samples/sample_OFF038_align.sam \
	-s ./samples/sample_OFF039_align.sam \
	-s ./samples/sample_OFF041_align.sam \
	-s ./samples/sample_OFF042_align.sam \
	-s ./samples/sample_OFF043_align.sam \
	-s ./samples/sample_OFF044_align.sam \
	-s ./samples/sample_OFF045_align.sam \
	-s ./samples/sample_OFF046_align.sam \
	-s ./samples/sample_OFF047_align.sam \
	-s ./samples/sample_OFF049_align.sam \
	-s ./samples/sample_OFF050_align.sam \
	-s ./samples/sample_OFF051_align.sam \
	-s ./samples/sample_OFF052_align.sam \
	-s ./samples/sample_OFF053_align.sam \
	-s ./samples/sample_OFF054_align.sam \
	-s ./samples/sample_OFF055_align.sam \
	-s ./samples/sample_OFF056_align.sam \
	-s ./samples/sample_OFF057_align.sam \
	-s ./samples/sample_OFF058_align.sam \
	-s ./samples/sample_OFF059_align.sam \
	-s ./samples/sample_OFF060_align.sam \
	-s ./samples/sample_OFF061_align.sam \
	-s ./samples/sample_OFF064_align.sam \
	-s ./samples/sample_OFF066_align.sam \
	-s ./samples/sample_OFF067_align.sam \
	-s ./samples/sample_OFF068_align.sam \
	-s ./samples/sample_OFF070_align.sam \
	-s ./samples/sample_OFF071_align.sam \
	-s ./samples/sample_OFF072_align.sam \
	-s ./samples/sample_OFF073_align.sam \
	-s ./samples/sample_OFF074_align.sam \
	-s ./samples/sample_OFF075_align.sam \
	-s ./samples/sample_OFF076_align.sam \
	-s ./samples/sample_OFF077_align.sam \
	-s ./samples/sample_OFF078_align.sam \
	-s ./samples/sample_OFF079_align.sam \
	-s ./samples/sample_OFF080_align.sam \
	-s ./samples/sample_OFF081_align.sam \
	-s ./samples/sample_OFF083_align.sam \
	-s ./samples/sample_OFF084_align.sam \
	-s ./samples/sample_OFF085_align.sam \
	-s ./samples/sample_OFF08623_align.sam \
	-s ./samples/sample_OFF086_align.sam \
	-s ./samples/sample_OFF088_align.sam \
	-s ./samples/sample_OFF089_align.sam \
	-s ./samples/sample_OFF090_align.sam \
	-s ./samples/sample_OFF091_align.sam \
	-s ./samples/sample_OFF092_align.sam \
	-s ./samples/sample_OFF093_align.sam \
	-s ./samples/sample_OFF094_align.sam \
	-s ./samples/sample_OFF095_align.sam \
	-s ./samples/sample_OFF096_align.sam \
	-s ./samples/sample_OFF097_align.sam \
	-s ./samples/sample_OFF100_align.sam \
	-s ./samples/sample_OFF101_align.sam \
	-s ./samples/sample_OFF102_align.sam \
	-s ./samples/sample_OFF103_align.sam \
	-s ./samples/sample_OFF105_align.sam \
	-s ./samples/sample_OFF106_align.sam \
	-s ./samples/sample_OFF110_align.sam \
	-s ./samples/sample_OFF111_align.sam \
	-s ./samples/sample_OFF112_align.sam \
	-s ./samples/sample_OFF113_align.sam \
	-s ./samples/sample_OFF114_align.sam \
	-s ./samples/sample_OFF115_align.sam \
	-s ./samples/sample_OFF117_align.sam \
	-s ./samples/sample_OFF118_align.sam \
	-s ./samples/sample_OFF119_align.sam \
	-s ./samples/sample_OFF120_align.sam \
	-s ./samples/sample_OFF121_align.sam \
	-s ./samples/sample_OFF122_align.sam \
	-s ./samples/sample_OFF123_align.sam \
	-s ./samples/sample_OFF124_align.sam \
	-s ./samples/sample_OFF125_align.sam \
	-s ./samples/sample_OFF126_align.sam \
	-s ./samples/sample_OFF127_align.sam \
	-s ./samples/sample_OFF134_align.sam \
	-s ./samples/sample_OFF135_align.sam \
	-s ./samples/sample_OFF136_align.sam \
	-s ./samples/sample_OFF137_align.sam \
	-s ./samples/sample_OFF138_align.sam \
	-s ./samples/sample_OFF139_align.sam \
	-s ./samples/sample_OFF140_align.sam \
	-s ./samples/sample_OFF142_align.sam \
	-s ./samples/sample_OFF143_align.sam \
	-s ./samples/sample_OFF144_align.sam \
	-s ./samples/sample_OFF145_align.sam \
	-s ./samples/sample_OFF146_align.sam \
	-s ./samples/sample_OFF149_align.sam \
	-s ./samples/sample_OFF150_align.sam \
	-s ./samples/sample_OFF151_align.sam \
	-s ./samples/sample_OFF152_align.sam \
	-s ./samples/sample_OFF153_align.sam \
	-s ./samples/sample_OFF154_align.sam \
	-s ./samples/sample_OFF155_align.sam \
	-s ./samples/sample_OFF156_align.sam \
	-s ./samples/sample_OFF157_align.sam \
	-s ./samples/sample_OFF158_align.sam \
	-s ./samples/sample_OFF159_align.sam \
	-s ./samples/sample_OFF160_align.sam \
	-s ./samples/sample_OFF161_align.sam \
	-s ./samples/sample_OFF165_align.sam \
	-s ./samples/sample_OFF166_align.sam \
	-s ./samples/sample_OFF167_align.sam \
	-s ./samples/sample_OFF168_align.sam \
	-s ./samples/sample_OFF169_align.sam \
	-s ./samples/sample_OFF170_align.sam \
	-s ./samples/sample_OFF171_align.sam \
	-s ./samples/sample_OFF172_align.sam \
	-s ./samples/sample_OFF173_align.sam \
	-s ./samples/sample_OFF174_align.sam \
	-s ./samples/sample_OFF175_align.sam \
	-s ./samples/sample_OFF176_align.sam \
	-s ./samples/sample_OFF177_align.sam \
	-s ./samples/sample_OFF178_align.sam \
	-s ./samples/sample_OFF179_align.sam \
	-s ./samples/sample_OFF181_align.sam \
	-s ./samples/sample_OFF182_align.sam \
	-s ./samples/sample_OFF183_align.sam \
	-s ./samples/sample_OFF184_align.sam \
	-s ./samples/sample_OFF185_align.sam \
	-s ./samples/sample_OFF186_align.sam \
	-s ./samples/sample_OFF187_align.sam \
	-s ./samples/sample_OFF188_align.sam \
	-s ./samples/sample_OFF189_align.sam \
	-s ./samples/sample_PRM001_align.sam \
	-s ./samples/sample_PRM002_align.sam \
	-s ./samples/sample_PRM003_align.sam \
	-s ./samples/sample_PRM005_align.sam \
	-s ./samples/sample_PRM006_align.sam \
	-s ./samples/sample_PRM007_align.sam \
	-s ./samples/sample_PRM009_align.sam \
	-s ./samples/sample_PRM010_align.sam \
	-s ./samples/sample_PRM011_align.sam \
	-s ./samples/sample_PRM012_align.sam \
	-s ./samples/sample_PRM013_align.sam \
	-s ./samples/sample_PRM014_align.sam \
	-s ./samples/sample_PRM015_align.sam \
	-s ./samples/sample_PRM016_align.sam \
	-s ./samples/sample_PRM017_align.sam \
	-s ./samples/sample_PRM018_align.sam \
	-s ./samples/sample_PRM019_align.sam \
	-s ./samples/sample_PRM022_align.sam \
	-s ./samples/sample_PRM023_align.sam \
	-s ./samples/sample_PRM025_align.sam \
	-s ./samples/sample_PRM026_align.sam \
	-s ./samples/sample_PRM028_align.sam \
	-s ./samples/sample_PRM041_align.sam \
	-s ./samples/sample_PRM042_align.sam \
	-s ./samples/sample_PRM043_align.sam \
	-s ./samples/sample_PRM044_align.sam \
	-s ./samples/sample_PRM045_align.sam \
	-s ./samples/sample_PRM046_align.sam \
	-s ./samples/sample_PRM047_align.sam \
	-s ./samples/sample_PRM048_align.sam \
	-s ./samples/sample_PRM049_align.sam \
	-s ./samples/sample_PRM050_align.sam \
	-s ./samples/sample_PRM051_align.sam \
	-s ./samples/sample_PRM053_align.sam \
	-s ./samples/sample_PRM054_align.sam \
	-s ./samples/sample_PRM055_align.sam \
	-s ./samples/sample_PRM056_align.sam \
	-s ./samples/sample_PRM057_align.sam \
	-s ./samples/sample_PRM058_align.sam \
	-s ./samples/sample_PRM059_align.sam \
	-s ./samples/sample_PRM060_align.sam \
	-s ./samples/sample_PRM061_align.sam \
	-s ./samples/sample_PRM062_align.sam \
	-s ./samples/sample_PRM064_align.sam \
	-s ./samples/sample_PRM065_align.sam \
	-s ./samples/sample_PRM066_align.sam \
	-s ./samples/sample_PRM067_align.sam \
	-s ./samples/sample_PRM068_align.sam \
	-s ./samples/sample_PRM069_align.sam \
	-s ./samples/sample_PRM070_align.sam \
	-s ./samples/sample_PRM071_align.sam \
	-s ./samples/sample_PRM072_align.sam \
	-s ./samples/sample_PRM073_align.sam \
	-s ./samples/sample_PRM074_align.sam \
	-s ./samples/sample_PRM076_align.sam \
	-s ./samples/sample_PRM077_align.sam \
	-s ./samples/sample_PRM078_align.sam \
	-s ./samples/sample_PRM079_align.sam \
	-s ./samples/sample_PRM080_align.sam \
	-s ./samples/sample_PRM081_align.sam \
	-s ./samples/sample_PRM082_align.sam \
	-s ./samples/sample_PRM083_align.sam \
	-s ./samples/sample_PRM084_align.sam \
	-s ./samples/sample_PRM085_align.sam \
	-s ./samples/sample_PRM086-23_align.sam \
	-s ./samples/sample_PRM086R_align.sam \
	-s ./samples/sample_PRM087_align.sam \
	-s ./samples/sample_PRM088_align.sam \
	-s ./samples/sample_PRM089_align.sam \
	-s ./samples/sample_PRM090_align.sam \
	-s ./samples/sample_PRM091_align.sam \
	-s ./samples/sample_PRM092_align.sam \
	-s ./samples/sample_PRM093_align.sam \
	-s ./samples/sample_PRM096_align.sam \
	-s ./samples/sample_PRM097_align.sam \
	-s ./samples/sample_PRM098_align.sam \
	-s ./samples/sample_PRM099_align.sam \
	-s ./samples/sample_PRM100_align.sam \
	-s ./samples/sample_PRM101_align.sam \
	-s ./samples/sample_PRM102_align.sam \
	-s ./samples/sample_PRM103_align.sam \
	-s ./samples/sample_PRM104_align.sam \
	-s ./samples/sample_PRM105_align.sam \
	-s ./samples/sample_PRM106_align.sam \
	-s ./samples/sample_PRM107_align.sam \
	-s ./samples/sample_PRM108_align.sam \
	-s ./samples/sample_PRM109_align.sam \
	-s ./samples/sample_PRM110_align.sam \
	-s ./samples/sample_PRM111_align.sam \
	-s ./samples/sample_PRM112_align.sam \
	-s ./samples/sample_PRM113_align.sam \
	-s ./samples/sample_PRM114_align.sam \
	-s ./samples/sample_PRM115_align.sam \
	-s ./samples/sample_PRM117_align.sam \
	-s ./samples/sample_PRM118_align.sam \
	-s ./samples/sample_PRM119_align.sam \
	-s ./samples/sample_PRM120_align.sam \
	-s ./samples/sample_PRM121_align.sam \
	-s ./samples/sample_PRM122_align.sam \
	-s ./samples/sample_PRM124_align.sam \
	-s ./samples/sample_PRM125_align.sam \
	-s ./samples/sample_PRM126_align.sam \
	-s ./samples/sample_PRM127_align.sam \
	-s ./samples/sample_PRM128_align.sam \
	-s ./samples/sample_PRM129_align.sam \
	-s ./samples/sample_PRM130_align.sam \
	-s ./samples/sample_PRM131_align.sam \
	-s ./samples/sample_PRM132_align.sam \
	-s ./samples/sample_PRM133_align.sam \
	-s ./samples/sample_PRM134_align.sam \
	-s ./samples/sample_PRM135_align.sam \
	-s ./samples/sample_PRM136_align.sam \
	-s ./samples/sample_PRM137_align.sam \
	-s ./samples/sample_PRM139_align.sam \
	-s ./samples/sample_PRM140_align.sam \
	-s ./samples/sample_PRM143_align.sam \
	-s ./samples/sample_PRM144_align.sam \
	-s ./samples/sample_PRM145_align.sam \
	-s ./samples/sample_PRM146_align.sam \
	-s ./samples/sample_PRM147_align.sam \
	-s ./samples/sample_PRM148_align.sam \
	-s ./samples/sample_PRM149_align.sam \
	-s ./samples/sample_PRM150_align.sam \
	-s ./samples/sample_PRM151_align.sam \
	-s ./samples/sample_PRM152_align.sam \
	-s ./samples/sample_PRM153_align.sam \
	-s ./samples/sample_PRM154_align.sam \
	-s ./samples/sample_PRM155_align.sam \
	-s ./samples/sample_PRM156_align.sam \
	-s ./samples/sample_PRM159_align.sam \
	-s ./samples/sample_PRM160_align.sam \
	-s ./samples/sample_PRM161_align.sam \
	-s ./samples/sample_PRM162_align.sam \
	-s ./samples/sample_PRM163_align.sam \
	-s ./samples/sample_PRM164_align.sam \
	-s ./samples/sample_PRM165_align.sam \
	-s ./samples/sample_PRM166_align.sam \
	-s ./samples/sample_PRM167_align.sam \
	-s ./samples/sample_PRM168_align.sam \
	-s ./samples/sample_PRM169_align.sam \
	-s ./samples/sample_PRM171_align.sam \
	-s ./samples/sample_PRM172_align.sam \
	-s ./samples/sample_PRM173_align.sam \
	-s ./samples/sample_PRM174_align.sam \
	-s ./samples/sample_PRM175_align.sam \
	-s ./samples/sample_PRM176_align.sam \
	-s ./samples/sample_PRM177-1_align.sam \
	-s ./samples/sample_PRM177_align.sam \
	-s ./samples/sample_PRM178_align.sam \
	-s ./samples/sample_PRM179_align.sam \
	-s ./samples/sample_PRM181_align.sam \
	-s ./samples/sample_PRM182_align.sam \
	-s ./samples/sample_PRM183_align.sam \
	-s ./samples/sample_PRM184_align.sam \
	-s ./samples/sample_PRM185_align.sam \
	-s ./samples/sample_PRM186_align.sam \
	-s ./samples/sample_PRM187_align.sam \
	-s ./samples/sample_PRM188_align.sam \
	-s ./samples/sample_PRM189_align.sam